<?php

	/*
		This file should show the payment option in the checkout form.
	*/

	// Prevent this file from being accessed directly
	if(defined('WB_PATH') == false)
	{
		exit('Cannot access this file directly'); 
	}

	// Include info file
	include(WB_PATH . '/modules/bakery/payment_methods/idealcheckoutpaysafecard/info.php');


	// Look for payment method language file
	if(LANGUAGE_LOADED)
	{
		include(WB_PATH . '/modules/bakery/payment_methods/idealcheckoutpaysafecard/languages/EN.php');

		if(file_exists(WB_PATH . '/modules/bakery/payment_methods/idealcheckoutpaysafecard/languages/' . LANGUAGE . '.php'))
		{
			include(WB_PATH . '/modules/bakery/payment_methods/idealcheckoutpaysafecard/languages/' . LANGUAGE . '.php');
		}
	}

	require_once(WB_PATH . '/idealcheckout/includes/library.php');
	$aDatabaseSettings = idealcheckout_getDatabaseSettings();


	// Lookup transaction
	$sql = "SELECT * FROM `" . $aDatabaseSettings['table'] . "` WHERE (`order_id` = '" . $_SESSION['bakery']['order_id'] . "') ORDER BY `id` DESC LIMIT 1;";
	$oRecordset = $database->query($sql);

	if($oRecordset->numRows())
	{
		$oRecord = $oRecordset->fetchRow();
	}
	else
	{
		$sStoreCode = idealcheckout_getStoreCode();
		$sGatewayCode = 'paysafecard';
		$sLanguageCode = 'nl'; // nl, de, en
		$sCountryCode = '';
		$sCurrencyCode = 'EUR';

		$sOrderId = $_SESSION['bakery']['order_id'];
		$sOrderCode = idealcheckout_getRandomCode(32);
		$sTransactionId = idealcheckout_getRandomCode(32);
		$sTransactionCode = idealcheckout_getRandomCode(32);
		$fTransactionAmount = $_SESSION['bakery']['order_total'];
		$sTransactionDescription = idealcheckout_getTranslation($sLanguageCode, 'idealcheckout', 'Webshop order #{0}', array($sOrderId));
		$sTransactionPaymentUrl = $setting_continue_url . '?pm=' . $payment_method;
		$sTransactionSuccessUrl = $sTransactionPaymentUrl;
		$sTransactionPendingUrl = $sTransactionPaymentUrl;
		$sTransactionFailureUrl = $sTransactionPaymentUrl;

		// Insert into #_idealcheckout
		$sql = "INSERT INTO `" . $aDatabaseSettings['table'] . "` SET 
`id` = NULL, 
`order_id` = '" . idealcheckout_escapeSql($sOrderId) . "', 
`order_code` = '" . idealcheckout_escapeSql($sOrderCode) . "', 
`order_params` = NULL, 
`store_code` = " . (empty($sStoreCode) ? "NULL" : "'" . idealcheckout_escapeSql($sStoreCode) . "'") . ", 
`gateway_code` = '" . idealcheckout_escapeSql($sGatewayCode) . "', 
`language_code` = " . (empty($sLanguageCode) ? "NULL" : "'" . idealcheckout_escapeSql($sLanguageCode) . "'") . ", 
`country_code` = " . (empty($sCountryCode) ? "NULL" : "'" . idealcheckout_escapeSql($sCountryCode) . "'") . ", 
`currency_code` = '" . idealcheckout_escapeSql($sCurrencyCode) . "', 
`transaction_id` = '" . idealcheckout_escapeSql($sTransactionId) . "', 
`transaction_code` = '" . idealcheckout_escapeSql($sTransactionCode) . "', 
`transaction_params` = NULL, 
`transaction_date` = '" . idealcheckout_escapeSql(time()) . "', 
`transaction_amount` = '" . idealcheckout_escapeSql($fTransactionAmount) . "', 
`transaction_description` = '" . idealcheckout_escapeSql($sTransactionDescription) . "', 
`transaction_status` = NULL, 
`transaction_url` = NULL, 
`transaction_payment_url` = '" . idealcheckout_escapeSql($sTransactionPaymentUrl) . "', 
`transaction_success_url` = '" . idealcheckout_escapeSql($sTransactionSuccessUrl) . "', 
`transaction_pending_url` = '" . idealcheckout_escapeSql($sTransactionPendingUrl) . "', 
`transaction_failure_url` = '" . idealcheckout_escapeSql($sTransactionFailureUrl) . "', 
`transaction_log` = NULL;";

		$database->query($sql);

		// Lookup transaction
		$sql = "SELECT * FROM `" . $aDatabaseSettings['table'] . "` WHERE (`order_id` = '" . $_SESSION['bakery']['order_id'] . "') ORDER BY `id` DESC LIMIT 1;";
		$oRecordset = $database->query($sql);
		$oRecord = $oRecordset->fetchRow();
	}


	if($oRecord)
	{
		// Setup HTML
		$html = '
<tr>
	<td colspan="2" class="mod_bakery_pay_submit_f">
		<h3 class="mod_bakery_pay_h_f">PaySafeCard</h3>
		<p>Direct online uw bestelling afrekenen met PaySafeCard!</p>

		<form action="' . htmlspecialchars(WB_URL . '/idealcheckout/setup.php?order_id=' . $oRecord['order_id'] . '&order_code=' . $oRecord['order_code']) . '" method="post" name="gateway-idealcheckoutpaysafecard">
			<input type="hidden" name="payment_method" value="idealcheckoutpaysafecard">
			<input type="submit" value="Betalen met PaySafeCard">
		</form>';

		// Direct checkout
		if($skip_checkout)
		{
			$html .= '<script type="text/javascript"> function doAutoSubmit() { document.forms[\'gateway-idealcheckoutpaysafecard\'].submit(); } setTimeout(\'doAutoSubmit()\', 100); </script>';
		}

		$html .= '
	</td>
</tr>
<tr>
	<td colspan="2"><hr class="mod_bakery_hr_f" /></td>
</tr>';
	}
	else
	{
		$html .= '<p>Cannot load transaction record from database for order #' . $oRecord['order_id'] . '.</p>';
	}

	// Output HTML
	echo $html;

?>