<?php

	// Load gateway setings
	require_once(dirname(dirname(dirname(dirname(dirname(dirname(__FILE__)))))) . '/idealcheckout/includes/library.php');

	$aGatewaySettings = idealcheckout_getGatewaySettings(false, 'visa');


	$sHtml = '
<h1 style="text-align: left;">iDEAL Checkout - Visa</h1>
<p>Via deze plugin kunt u Visa betalingen ontvangen in uw webshop via diverse Payment Service Providers.</p>
<p>Deze plugin is momenteel geconfigureerd om Visa transacties te verwerken via <b>' . htmlspecialchars($aGatewaySettings['GATEWAY_NAME']) . '</b>.<br>Meer informatie over deze Payment Service Provider vind u op <a href="' . htmlspecialchars($aGatewaySettings['GATEWAY_WEBSITE']) . '" style="text-decoration: underline;" target="_blank">' . htmlspecialchars($aGatewaySettings['GATEWAY_WEBSITE']) . '</a></p>';

	if($aGatewaySettings['GATEWAY_VALIDATION'])
	{
		$sHtml .= '
<p>&nbsp;</p>
<h2>Transacties Controleren</h2>
<p>Controleer de status van alle openstaande transacties bij uw Payment Service Provider.</p>
<p><input type="button" value="Controleer openstaande transacties." onclick="javascript: window.open(\'' . idealcheckout_getRootUrl(2) . 'idealcheckout/validate.php?gateway=visa\', \'popup\', \'directories=no,height=550,location=no,menubar=no,resizable=yes,scrollbars=yes,status=no,toolbar=no,width=750\');"></p>';
	}

	$sHtml .= '
<p>&nbsp;</p>
<h2>Over deze plugin</h2>
<p>Deze Visa plugin is ontwikkeld door <a href="https://www.ideal-checkout.nl" style="text-decoration: underline;" target="_blank">iDEAL Checkout</a> en is GRATIS te downloaden via <a href="http://www.ideal-checkout.nl" style="text-decoration: underline;" target="_blank">http://www.ideal-checkout.nl</a>.<br><br>- Voor vragen over deze plugin kunt u kijken op <a href="http://www.ideal-checkout.nl" target="_blank">http://www.ideal-checkout.nl</a> of mailen naar <a href="mailto:info@ideal-checkout.nl">info@ideal-checkout.nl</a><br>- Feedback en donaties<br>- Het gebruik van onze plugins/scripts is geheel op eigen risico.</p>
<p>&nbsp;</p>
Beheer de instellingen van deze plugin via het configuratiebestand: /idealcheckout/configuration/visa.php';



// SETTINGS - USED BY BACKEND
$MOD_BAKERY['TXT_NO_PAYMENT_METHOD_SETTING'] = $sHtml;


// USED BY FILE bakery/payment_methods/ideal_professional/processor.php
$MOD_BAKERY[$payment_method]['TXT_PAYMENT'] = 'Visa';
$MOD_BAKERY[$payment_method]['TXT_PENDING'] = 'In behandeling';
$MOD_BAKERY[$payment_method]['TXT_TRANSACTION_STATUS'] = 'Betaalstatus';
$MOD_BAKERY[$payment_method]['TXT_ORDER_DESCRIPTION'] = 'Webshop Bestelling';
$MOD_BAKERY[$payment_method]['TXT_PAY'] = 'Betalen met Visa';


// USED BY FILE bakery/view_confirmation.php
$MOD_BAKERY[$payment_method]['TXT_SUCCESS'] = 'U ontvangt een bevestigings email met betaal instructies.';
$MOD_BAKERY[$payment_method]['TXT_SHIPMENT'] = 'Zodra het bedrag is bijgeschreven op onze bankrekening verzenden wij de bestelde artikelen.';
$MOD_BAKERY[$payment_method]['ERROR'] = 'Er is een fout opgetreden bij het verwerken van de betaling. Probeer het later opnieuw.';
$MOD_BAKERY[$payment_method]['CANCELED'] = 'Uw betaling is geannuleerd.<br />Wilt u verder gaan met winkelen?';

// EMAIL CUSTOMER
$MOD_BAKERY[$payment_method]['EMAIL_SUBJECT_CUSTOMER'] = 'Bevestiging en factuur voor uw [SHOP_NAME] order';
$MOD_BAKERY[$payment_method]['EMAIL_BODY_CUSTOMER'] = 'Geachte [CUSTOMER_NAME]

Bedankt voor uw bestelling bij [SHOP_NAME].
Hieronder vind u een overzicht van de door u bestelde produkten:
[ITEM_LIST]

U wordt verzocht het totaalbedrag over te maken op bankrekening 
[BANK_ACCOUNT]

Zodra wij het bedrag hebben ontvangen zullen wij de goederen verzenden naar:

[ADDRESS]


Bedankt voor het in ons gestelde vertrouwen.

Met vriendelijke groeten,
[SHOP_NAME]


';

// EMAIL SHOP
$MOD_BAKERY[$payment_method]['EMAIL_SUBJECT_SHOP'] = 'Nieuwe bestelling bij [SHOP_NAME]';
$MOD_BAKERY[$payment_method]['EMAIL_BODY_SHOP'] = 'Geachte [SHOP_NAME] Administrator

NIEUWE BESTELLING BIJ [SHOP_NAME]:
	Bestelling #: [ORDER_ID]
	Betaal methode: iDEAL Checkout - Visa

Aflever adres:
[ADDRESS]

Factuur adres:
[CUST_ADDRESS]

Bestellijst: 
[ITEM_LIST]


Met vriendelijke groet,
[SHOP_NAME]


';



	// If utf-8 is set as default charset convert some iso-8859-1 strings to utf-8 
	if(defined('DEFAULT_CHARSET') && DEFAULT_CHARSET == 'utf-8')
	{
		$MOD_BAKERY[$payment_method]['EMAIL_SUBJECT_CUSTOMER'] = utf8_encode($MOD_BAKERY[$payment_method]['EMAIL_SUBJECT_CUSTOMER']);
		$MOD_BAKERY[$payment_method]['EMAIL_BODY_CUSTOMER'] = utf8_encode($MOD_BAKERY[$payment_method]['EMAIL_BODY_CUSTOMER']);
		$MOD_BAKERY[$payment_method]['EMAIL_SUBJECT_SHOP'] = utf8_encode($MOD_BAKERY[$payment_method]['EMAIL_SUBJECT_SHOP']);
		$MOD_BAKERY[$payment_method]['EMAIL_BODY_SHOP'] = utf8_encode($MOD_BAKERY[$payment_method]['EMAIL_BODY_SHOP']);
	}

?>